aboutsummaryrefslogtreecommitdiff
path: root/explodepkg.sbopkglint
diff options
context:
space:
mode:
authorB. Watson <urchlay@slackware.uk>2026-04-30 01:12:57 -0400
committerB. Watson <urchlay@slackware.uk>2026-04-30 01:12:57 -0400
commitf7ccde90c735457f744667a6ff98c5c24df756b8 (patch)
tree4be9705b566b31320f254c49822c45f99c58d743 /explodepkg.sbopkglint
parentef26c51a96daff594690c18690131c653744652c (diff)
downloadsbo-maintainer-tools-f7ccde90c735457f744667a6ff98c5c24df756b8.tar.gz
Use custom explodepkg replacement that actually reports errors (such as, disk full).
Diffstat (limited to 'explodepkg.sbopkglint')
-rwxr-xr-xexplodepkg.sbopkglint130
1 files changed, 130 insertions, 0 deletions
diff --git a/explodepkg.sbopkglint b/explodepkg.sbopkglint
new file mode 100755
index 0000000..9d3a511
--- /dev/null
+++ b/explodepkg.sbopkglint
@@ -0,0 +1,130 @@
+#!/bin/bash
+
+# 20260429 bkw: This is a *modified* version of explodepkg, part
+# of sbo-maintainer-tools, intended for use with sbopkglint.
+
+# Copyright information for the original explodepkg:
+
+# Copyright 1994, 1998, 2000 Patrick Volkerding, Concord, CA, USA
+# Copyright 2001, 2003 Slackware Linux, Inc., Concord, CA, USA
+# Copyright 2007, 2009, 2017, 2018 Patrick Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Copyright for this modified version (explodepkg.sbopkglint) is
+# assigned to the original copyright holders, under the original terms.
+# All I did was change a few lines at the end of the script to make it
+# report errors instead of silently ignore them.
+
+if [ $# = 0 ]; then
+ cat << EOF
+Usage: explodepkg.sbopkglint package_name [package_name2, ...]
+
+Explodes a Slackware compatible software package
+(or any tar+{gzip,bzip2,lz,xz archive) in the current directory.
+Equivalent to (for each package listed):
+
+ ( umask 000 ; cat package_name | COMPRESSOR -dc | tar xpvf package_name )
+
+Note: This should only be used for debugging or examining packages, not for
+installing them. It doesn't execute installation scripts or update the package
+indexes in /var/lib/pkgtools/packages and /var/lib/pkgtools/scripts.
+
+Note: explodepkg.sbopkglint should only be called by sbopkglint. If
+you need to extract a package with explodepkg, you should be using the
+real one from Slackware's pkgtools (/sbin/explodepkg).
+
+EOF
+fi
+
+# Set maximum number of threads to use. By default, this will be the number
+# of CPU threads:
+THREADS="$(nproc)"
+
+# Main loop:
+for PKG in $* ; do
+ echo "Exploding package $PKG in current directory:"
+ # Determine extension:
+ packageext="$( echo $PKG | rev | cut -f 1 -d . | rev)"
+ # Determine compression utility:
+ case $packageext in
+ 'tgz' )
+ packagecompression=gzip
+ ;;
+ 'gz' )
+ packagecompression=gzip
+ ;;
+ 'tbz' )
+ if which lbzip2 1> /dev/null 2> /dev/null ; then
+ packagecompression=lbzip2
+ else
+ packagecompression=bzip2
+ fi
+ ;;
+ 'bz2' )
+ if which lbzip2 1> /dev/null 2> /dev/null ; then
+ packagecompression=lbzip2
+ else
+ packagecompression=bzip2
+ fi
+ ;;
+ 'tlz' )
+ if which plzip 1> /dev/null 2> /dev/null ; then
+ packagecompression="plzip --threads=${THREADS}"
+ elif which lzip 1> /dev/null 2> /dev/null ; then
+ packagecompression=lzip
+ else
+ echo "ERROR: lzip compression utility not found in \$PATH."
+ exit 3
+ fi
+ ;;
+ 'lz' )
+ if which plzip 1> /dev/null 2> /dev/null ; then
+ packagecompression="plzip --threads=${THREADS}"
+ elif which lzip 1> /dev/null 2> /dev/null ; then
+ packagecompression=lzip
+ else
+ echo "ERROR: lzip compression utility not found in \$PATH."
+ exit 3
+ fi
+ ;;
+ 'lzma' )
+ packagecompression=lzma
+ ;;
+ 'txz' )
+ packagecompression="xz --threads=${THREADS}"
+ ;;
+ 'xz' )
+ packagecompression="xz --threads=${THREADS}"
+ ;;
+ esac
+ ( umask 000 ; cat $PKG | $packagecompression -dc | tar --xattrs --xattrs-include='*' --keep-directory-symlink -xpvf - )
+ RETVAL="$?"
+ if [ -r install/doinst.sh ]; then
+ echo
+ echo "An installation script was detected in ./install/doinst.sh, but"
+ echo "was not executed."
+ fi
+ if [ "$RETVAL" != "0" ]; then
+ echo
+ echo "tar extraction failed with status $RETVAL"
+ fi
+done
+
+exit "$RETVAL"